

#include "vgev.h"
#include "vgev_data.h"


/* **************************************************************
************************************************************** */
VGEVplatform_data::VGEVplatform_data(basic_platform *x) : platform_data(x) {

   symbol2D = NULL;
   tgev = NULL;
}


/* **************************************************************
************************************************************** */
VGEVplatform_data::~VGEVplatform_data() {
	
   if (symbol2D) {
      symbol_manager.remove(symbol2D);
      delete symbol2D;
   }

}


/* **************************************************************
************************************************************** */
void VGEVplatform_data::update(double *machine_time) {

   copyarray3(orient, parent->plat_clone.rpy);  // 0 degrees is north
   
   copyarray3(xyz, parent->plat_clone.pos);

   xy_to_deg(xyz[0], xyz[1], &symbol2D->lat, &symbol2D->lon);

   symbol2D->recalc(tgev);
}

   
/* **************************************************************
************************************************************** */
void VGEVplatform_data::render(iface *isim) {

   
}


/* **************************************************************
TP semcode format - SSSCXXXXX, S = symbol index, C = color index
************************************************************** */
int VGEVplatform_data::init(iface *isim, correlate *basis, symbol_correlation_type *str) {

   icon_type *ptr;

   symbol_manager.insert(symbol2D = new platform_symbol, NULL);
   symbol2D->source = this;
   symbol2D->flags = DRAWABLEFLAG_PLATFORM;
   name.stringcpy(&str->sym_label);

   for (ptr = (icon_type *)iconman.head; ptr && ptr->type != str->sym_2D; ptr = (icon_type *)ptr->next);

   symbol2D->icon = ptr;

   if (!ptr) {
      sprintf(perror_buffer, "Warning:  Unable to locate symbol \"%d\"...\n", str->sym_2D);
      pprintf(perror_buffer);
   }

   copyarray3(symbol2D->color, str->sym_2D_color);
   
   return 1;
}







